import { Contract } from 'web3-eth-contract'
import Web3 from 'web3'
import { Account } from 'web3-core'
const abi = require('abis/ClaimBoxFactory.json').abi

export class ActivityReactor {
  private web3: Web3
  private contract: Contract
  private account: Account
  constructor({ web3, address }: { web3: Web3; address: string }) {
    this.web3 = web3
    this.account = this.web3.eth.accounts.wallet[0]
    this.contract = new this.web3.eth.Contract(abi, address, { from: this.account.address })
  }

  /**
   * 查询用户可mint的数量
   */
  async getMintableCount({ address, user }: { address?: string; user: string }) {
    const contract = address ? new this.web3.eth.Contract(abi, address, { from: this.account.address }) : this.contract
    return await contract.methods.claimHistory(user).call()
  }
}
