import { BlockChain } from 'chain/BlockChain'
import { singleton } from 'decorators/singleton'
import logger from 'logger/logger'
import * as schedule from 'node-schedule'

@singleton
export default class BlocknumSchedule {
  async parseAllRecord() {
    try {
      await new BlockChain().updateCurrenBlockNum()
    } catch (err) {
      logger.info('updateCurrenBlockNum error', err.message || err)
    }
  }
  scheduleAll() {
    const job = schedule.scheduleJob('*/5 * * * * *', async () => {
      this.parseAllRecord()
    })
  }
}
