import axios from 'axios'
import { singleton } from 'decorators/singleton'
import logger from 'logger/logger'
import { hmacSha256 } from 'utils/security.util'

const REPORT_TASK_URI = '/api/internal/update_task'

const calcHash = function (data: any) {
  return hmacSha256(JSON.stringify(data), process.env.HASH_SALT)
}
@singleton
export class InfoSvr {
  reportTaskResult(data: any) {
    let url = data.cb
    delete data.cb
    data.sign = calcHash(data)
    logger.info('report to info svr: ' + JSON.stringify(data))
    if (!url) {
      url = `${process.env.INFO_SVR_HOST}${REPORT_TASK_URI}`
    }
    let reqConfig: any = {
      method: 'post',
      url,
      headers: {
        'Content-Type': 'application/json',
      },
      data: JSON.stringify(data),
    }
    return axios(reqConfig)
  }
}
